import preset from 'ts-jest/presets/index.js';

/** @type {import('ts-jest').JestConfigWithTsJest} */
export default {
  ...preset.jsWithTsESM,
  testEnvironment: 'jsdom',
  setupFilesAfterEnv: ['<rootDir>/resources/ts/__tests__/config/importJestDOM.ts'],
  extensionsToTreatAsEsm: ['.ts'],
  transform: {
    '^.+\\.([tj]sx?)$': [
      'ts-jest',
      {
        tsconfig: 'tsconfig.json',
        useESM: true,
      },
    ],
  },
  testMatch: ['**/__tests__/!(config|mock)**/*.[jt]s?(x)', '**/?(*.)+(spec|test).[jt]s?(x)'],
  transformIgnorePatterns: ['<rootDir>/node_modules/(?!(@starconnect|nanoid)/)'],
  moduleNameMapper: {
    '\\.(css|less|scss|sass)$': '<rootDir>/resources/ts/__tests__/mock/styleMock.ts',
    '\\.(jpg|jpeg|png|gif|eot|otf|webp|svg|ttf|woff|woff2|mp4|webm|wav|mp3|m4a|aac|oga)$':
      '<rootDir>/resources/ts/__tests__/mock/fileMock.ts',
    '^test-utils$': '<rootDir>/resources/ts/utils/test-utils.tsx',
    '~/(.*)': '<rootDir>/resources/ts/$1',
  },
  // perf (you might try various options based on the available cores)
  maxWorkers: '8',
};
